# coding: utf-8

"""
    Prevision.io

    Prevision.io Studio APIs  # noqa: E501

    OpenAPI spec version: 1.0.5
    Contact: web@prevision.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class ConnectorApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def connector_connection_test(self, , **kwargs):  # noqa: E501
        """Connector connection test  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.connector_connection_test(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of connector to return (required)
        :return: InlineResponse20011
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.connector_connection_test_with_http_info(, **kwargs)  # noqa: E501
        else:
            (data) = self.connector_connection_test_with_http_info(, **kwargs)  # noqa: E501
            return data

    def connector_connection_test_with_http_info(self, , **kwargs):  # noqa: E501
        """Connector connection test  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.connector_connection_test_with_http_info(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of connector to return (required)
        :return: InlineResponse20011
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method connector_connection_test" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `connector_connection_test`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if '' in params:
            path_params['connectorId'] = params['']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['master_token']  # noqa: E501

        return self.api_client.call_api(
            '/connectors/{connectorId}/test', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20011',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def connectors_connector_id_databases_database_tables_get(self, , , **kwargs):  # noqa: E501
        """Get connector tables  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.connectors_connector_id_databases_database_tables_get(, , async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of connector to return (required)
        :param  : database name (required)
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.connectors_connector_id_databases_database_tables_get_with_http_info(, , **kwargs)  # noqa: E501
        else:
            (data) = self.connectors_connector_id_databases_database_tables_get_with_http_info(, , **kwargs)  # noqa: E501
            return data

    def connectors_connector_id_databases_database_tables_get_with_http_info(self, , , **kwargs):  # noqa: E501
        """Get connector tables  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.connectors_connector_id_databases_database_tables_get_with_http_info(, , async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of connector to return (required)
        :param  : database name (required)
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['', '']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method connectors_connector_id_databases_database_tables_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `connectors_connector_id_databases_database_tables_get`")  # noqa: E501
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `connectors_connector_id_databases_database_tables_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if '' in params:
            path_params['connectorId'] = params['']  # noqa: E501
        if '' in params:
            path_params['database'] = params['']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['master_token']  # noqa: E501

        return self.api_client.call_api(
            '/connectors/{connectorId}/databases/{database}/tables', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[str]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def connectors_connector_id_databases_get(self, , **kwargs):  # noqa: E501
        """Get connector databases  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.connectors_connector_id_databases_get(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of connector to return (required)
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.connectors_connector_id_databases_get_with_http_info(, **kwargs)  # noqa: E501
        else:
            (data) = self.connectors_connector_id_databases_get_with_http_info(, **kwargs)  # noqa: E501
            return data

    def connectors_connector_id_databases_get_with_http_info(self, , **kwargs):  # noqa: E501
        """Get connector databases  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.connectors_connector_id_databases_get_with_http_info(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of connector to return (required)
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method connectors_connector_id_databases_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `connectors_connector_id_databases_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if '' in params:
            path_params['connectorId'] = params['']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['master_token']  # noqa: E501

        return self.api_client.call_api(
            '/connectors/{connectorId}/databases', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[str]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def connectors_connector_id_get(self, , **kwargs):  # noqa: E501
        """Get one connector  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.connectors_connector_id_get(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of connector to return (required)
        :param  : select all database tables
        :param  : select all bucket files
        :param  : select all tables
        :return: Definitionsconnector
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.connectors_connector_id_get_with_http_info(, **kwargs)  # noqa: E501
        else:
            (data) = self.connectors_connector_id_get_with_http_info(, **kwargs)  # noqa: E501
            return data

    def connectors_connector_id_get_with_http_info(self, , **kwargs):  # noqa: E501
        """Get one connector  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.connectors_connector_id_get_with_http_info(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of connector to return (required)
        :param  : select all database tables
        :param  : select all bucket files
        :param  : select all tables
        :return: Definitionsconnector
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['', '', '', '']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method connectors_connector_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `connectors_connector_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if '' in params:
            path_params['connectorId'] = params['']  # noqa: E501

        query_params = []
        if '' in params:
            query_params.append(('database', params['']))  # noqa: E501
        if '' in params:
            query_params.append(('bucket', params['']))  # noqa: E501
        if '' in params:
            query_params.append(('tables', params['']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['master_token']  # noqa: E501

        return self.api_client.call_api(
            '/connectors/{connectorId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Definitionsconnector',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def connectors_connector_id_paths_get(self, , **kwargs):  # noqa: E501
        """Connector files and paths  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.connectors_connector_id_paths_get(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of connector to return (required)
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.connectors_connector_id_paths_get_with_http_info(, **kwargs)  # noqa: E501
        else:
            (data) = self.connectors_connector_id_paths_get_with_http_info(, **kwargs)  # noqa: E501
            return data

    def connectors_connector_id_paths_get_with_http_info(self, , **kwargs):  # noqa: E501
        """Connector files and paths  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.connectors_connector_id_paths_get_with_http_info(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of connector to return (required)
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method connectors_connector_id_paths_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `connectors_connector_id_paths_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if '' in params:
            path_params['connectorId'] = params['']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['master_token']  # noqa: E501

        return self.api_client.call_api(
            '/connectors/{connectorId}/paths', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[str]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def remove_connector(self, , **kwargs):  # noqa: E501
        """Remove connector  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.remove_connector(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of connector to delete (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.remove_connector_with_http_info(, **kwargs)  # noqa: E501
        else:
            (data) = self.remove_connector_with_http_info(, **kwargs)  # noqa: E501
            return data

    def remove_connector_with_http_info(self, , **kwargs):  # noqa: E501
        """Remove connector  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.remove_connector_with_http_info(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : ID of connector to delete (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method remove_connector" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `remove_connector`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if '' in params:
            path_params['connectorId'] = params['']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['master_token']  # noqa: E501

        return self.api_client.call_api(
            '/connectors/{connectorId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
